<template>
  <div :class="{ 'is-loading': isShowLoader }">
    <SectionHeading
      :task="task"
      :is-show-loader="isShowLoader"
      :header-sections="headerSections"
    />

    
    <SectionTab
      v-for="(group, i) in itemsGroups"
      :key="i"
      :title="group.fieldGroupTitle"
    >
      <div class="task-monitor-gutter">
        <div class="form-row form-halfed-wrapper">
          <div
            v-for="(field, i) in group.fields"
            :key="i"
            class="form-halfed-block"
          >
            <ObSelector
              :items="field.fieldValues"
              :label="field.fieldTitle"
              :data-uuid="field.uuid"
              :placeholder="(field.settings && field.settings.masks && field.settings.masks.length > 0) ? field.settings.masks[0] : field.fieldTitle"
              :disabled="!isNewTask"
              :value="getSelectorValue(field)"
              @input="changeInput(field, $event)"
              class="itemSave"
            />
          </div>
        </div>
      </div>
    </SectionTab>

    <div
      v-if="isNewTask"
      class="task-monitor-gutter task-monitor-buttons-container"
    >
      <ObButton
        label="Подтвердить"
        :disabled="isSubmitDisabled"
        @click="onSave"
      />
    </div>
  </div>
</template>

<script>
  import ObSelector from 'common-components/src/obComponents/obSelect'
  import ObButton from 'common-components/src/obComponents/obButton'
  import api from '@/api'
  import SectionMixin from './SectionMixin'

  export default {
    name: 'sectionConflict',
    mixins: [
      SectionMixin
    ],
    components: {
      ObSelector,
      ObButton
    },
    data () {
      return {
        itemsGroups: [],
        arraySave: [],
        taskData: {}
      }
    },
    watch: {
      async task () {
        this.arraySave = []
        this.itemsGroups = []

        if (Object.keys(this.task).length === 0) {
          return
        }

        await this.getFields()
      }
    },
    computed: {
      isSubmitDisabled: ({ arraySave }) => arraySave.some(f => !Object.values(f)[0])
    },
    async created () {
      await this.getFields()
    },
    methods: {
      async getFields () {
        this.isLoading = true

        try {
          const { data } = await api.taskMonitor[`get${this.currentKey}ConflictFields`](this.task.uuid)

          await this.updateData(data.domains[0])
        } catch (e) {
          console.error(e)

          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки данных'
          })
        }

        this.isLoading = false
      },
      async updateData (item) {
        this.taskData = item

        this.itemsGroups = await Promise.all(item.groups.map(async (group) => {
          let fields = await Promise.all(group.fields.map(async (field) => {
            this.arraySave.push({
              [field.uuid]: field.fieldValues.find(value => value.isPriority)?.uuid || ""
            })

            if (field.dictionary) {
              try {
                const { data } = await api.taskMonitor.getOptions(field.dictionary)

                field.fieldValues.forEach((fieldValue) => {
                  const values = data.values.filter(item => fieldValue.data.values?.includes(item.uuid))

                  fieldValue.data.value = values ? values.map(item => item.title).join(', ') : null
                })
              } catch (e) {
                console.error(e)

                this.$notification({
                  type: 'system_notification_error',
                  message: 'Ошибка загрузки данных'
                })
              }
            }

            return {
              ...field,
              fieldValues: field.fieldValues.map((fieldValue) => {
                let title
                let disabled = false

                if (fieldValue.data.externalServiceAnswerType === 'NO_ANSWER') {
                  title = 'Не распознано'
                  disabled = true
                } else {
                  switch (fieldValue.data.valueType) {
                    case 'BOOLEAN':
                      title = fieldValue.data.value ? 'Да' : 'Нет'
                      break

                    default:
                      title = fieldValue.data.value
                      break
                  }
                }

                return {
                  ...fieldValue,
                  subtitle: fieldValue.source ? fieldValue.source.title : false,
                  disabled,
                  title
                }
              })
            }
          }))

          fields = fields.sort((a, b) => a.pos - b.pos)

          return {
            ...group,
            _hidden: false,
            fields
          }
        }))

        this.itemsGroups = this.itemsGroups.sort((a, b) => a.fieldGroupPosition - b.fieldGroupPosition)
      },
      getSelectorValue (data) {
        const found = this.arraySave.find(el => el[data.uuid]);
        return found ? found[data.uuid] : "";
      },
      async onSave () {
        this.isLoading = true

        let notificationId = new Date().getTime() + 'save'

        this.$notification({
          type: 'system_notification_in_load',
          message: 'Сохранение',
          id: notificationId
        })

        try {
          // >>> Posting task payload
          try {

            const payload = {
              primaryValues: this.arraySave.map(f => {
                return ({ uuid: Object.values(f)[0] })
              })
            }

            const response = await api.taskMonitor[`post${this.currentKey}ConflictFields`](this.task.uuid, payload)

            if (response && response.error) {
              throw `Ошибка при сохранении данных: ${response.error}`
            }
          } catch (e) {
            throw e
          }

          // >>> Archiving task
          try {
            const res = await api.taskMonitor.postTaskExecuted(this.task.uuid, this.userUuid)

            if (res && res.error) {
              throw `Ошибка архивации задачи: ${res.error}`
            }
          } catch (e) {
            throw e
          }

          this.onTaskSuccess()
          this.onClose()
        } catch (e) {
          console.error(e)

          this.$notification({
            type: 'system_notification_error',
            message: e
          })
        }

        this.$notification({
          event: 'close',
          id: notificationId
        })

        this.isLoading = false
      },
      changeInput (field, valueUuid) {
        const index = this.arraySave.findIndex(f => Object.keys(f)[0] === field.uuid)
        this.$set(this.arraySave, index, { [field.uuid]: valueUuid })
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import '~common-components/src/static/css/mixins';

  .task-monitor-gutter {
    padding: 0 40px;
  }

  .task-monitor-buttons-container {
    display: flex;
    justify-content: flex-end;
    margin-top: 40px;
  }

  .form-tab.inactive {
    .form-tab-content {
      display: none;
    }

    &:last-of-type .form-tab-title {
      border-bottom: 1px solid $lavender;
    }
  }

  .form-tab-title {
    @include font-mixin(16px, 20px, 400, $color-blue-navy-blue);

    background: $background-color-light;
    padding: 8px 20px 7px;
    display: flex;
    align-items: center;
    border-top: 1px solid $lavender;
    box-sizing: border-box;
    cursor: pointer;
  }

  .form-tab-icon {
    font-size: 24px;
    margin-right: 10px;
  }

  .form-tab-content {
    margin-top: 20px;
  }

  .form-halfed-wrapper {
    display: flex;
    justify-content: space-between;
    flex-wrap: wrap;
  }

  .form-halfed-block {
    width: calc(50% - 10px);
    margin-bottom: 20px;
  }
</style>
